function SetWLANScanSSID(xml)
{
var d = document.getElementById('ssid');
d.value = GetXmlData(xml, "value");
}

var configUnsaved=false;//this variable is used to determine if the configuration is unsaved

function clearWLANProfileUpdates(formId)
{
var objForm = document.getElementById(formId);

if (objForm && objForm.tagName == 'FORM')
{
var formElements = objForm.elements;

for (var i = 0; i < formElements.length; i++)
{
var name = formElements[i].name;
if (name)
{
if(0==formElements[i].name.indexOf('wlan_profile_delete.') && formElements[i].type == 'checkbox')
formElements[i].checked=false;
if(0==formElements[i].name.indexOf('wlan_profile_state.') && formElements[i].type == 'checkbox')
{
formElements[i].checked = (formElements[i].getAttribute('wlan_profile_state')=="true");
}
}
}
}
updateWLANProfileApplyAndSubmit(formId);
return;
}

function getWLANProfileUpdates(formId)
{
var objForm = document.getElementById(formId);
var str = "";

if (objForm && objForm.tagName == 'FORM')
{
var formElements = objForm.elements;

for (var i = 0; i < formElements.length; i++)
{
var name = formElements[i].name;
if (name)
{
if (formElements[i].type == 'submit')
{
continue;
}
if (formElements[i].name == 'iehack')
{
continue;
}
var value=formElements[i].value;
if ((0==formElements[i].name.indexOf('wlan_profile_state.') ||
0==formElements[i].name.indexOf('wlan_profile_delete.')) &&
formElements[i].type == 'checkbox')
{
value=formElements[i].checked;
}
if (str != "")
{
str += '&';
}
str += encodeURIComponent(name) + "=" + encodeURIComponent(value);
}
}
}
if (str != "")
{
str += '&';
}
str += "iehack=";
return str;
}

function updateWLANProfileApplyAndSubmit(formId,force)
{
var bApplyButtonVisible=false;
var bSubmitButtonVisible=false;
if(formId!=null)
{
var objForm = document.getElementById(formId);
if (objForm && objForm.tagName == 'FORM')
{
var formElements = objForm.elements;

for (var i = 0; i < formElements.length; i++)
{
var name = formElements[i].name;
if (name)
{
if (formElements[i].type == 'submit')
{
continue;
}
if (formElements[i].name == 'iehack')
{
continue;
}
if (0==formElements[i].name.indexOf('wlan_profile_state.') &&
formElements[i].type == 'checkbox')
{
var oldState=formElements[i].getAttribute('wlan_profile_state');
var newState=formElements[i].checked;
if(newState.toString()!=oldState)
{
bApplyButtonVisible=true;
bSubmitButtonVisible=true;
}
}
if (0==formElements[i].name.indexOf('wlan_profile_delete.') &&
formElements[i].type == 'checkbox')
{
if(formElements[i].checked)
{
//var profileName=formElements[i].name.substr(formElements[i].name.indexOf('.')+1);
bApplyButtonVisible=true;
bSubmitButtonVisible=true;
}
}
}
}
}
}
if(force!=null)
{
SetSubmit(false);
configUnsaved=(force.toString()=="true")?true:false;
}
if(document.getElementById('wlanprofile_cancel_button'))
{
document.getElementById('wlanprofile_cancel_button').disabled=false;
document.getElementById('wlanprofile_cancel_button').style.visibility=bApplyButtonVisible?"visible":"hidden";
}
if(document.getElementById('wlanprofile_apply_button'))
{
document.getElementById('wlanprofile_apply_button').disabled=false;
document.getElementById('wlanprofile_apply_button').style.visibility=bApplyButtonVisible?"visible":"hidden";
}
if(document.getElementById('wlanprofile_submit_button'))
{
document.getElementById('wlanprofile_submit_button').disabled=false;
document.getElementById('wlanprofile_submit_button').style.visibility=(bSubmitButtonVisible || configUnsaved)?"visible":"hidden";
}
}
function EnableSubmitButton(xml)
{
if(document.getElementById('apply_button'))
{
document.getElementById('apply_button').disabled=false;
}
if(document.getElementById('test_button'))
{
document.getElementById('test_button').disabled=false;
}
if(document.getElementById('submit_button'))
{
document.getElementById('submit_button').disabled=false;
}
}
function EnableTestConnectionButton(enable)
{
if(document.getElementById('test_button'))
{
document.getElementById('test_button').disabled=!enable;
}
}
function SetNewProfileName(xml)
{
var d = document.getElementById('networkprofilename');
d.innerHTML = GetXmlData(xml, "value");
}
var timer=null;
function Rescan()
{
var d=document.getElementById('wlanScanTable');
if(d)
{
var nav3 = '3';
var netno = document.getElementById('hiddennetwork').innerHTML;
var nav2 = document.getElementById('hiddennetworkinterfacelink').innerHTML;
document.getElementById('hiddennetworkstatusconfig').innerHTML = nav3;
ajax_WLANScanSSID([true, ajaxGetFormValues('ssidform') + '&netnumber=' + netno + '&2=' + nav2 + '&3=' + nav3]);
}
}
function UpdateRescan()
{
var d = document.getElementById('autorefresh');
clearTimeout(timer);
timer=null;
if(d && d.checked)
{
timer=setTimeout("Rescan()",15*1000);//update every 15 seconds
}
document.getElementById('hiddennetworkscanautorefresh').innerHTML = d.checked.toString();
}
function SetAutoRefresh(xml)
{
var d = document.getElementById('autorefresh');
d.checked = document.getElementById('hiddennetworkscanautorefresh').innerHTML=="true"?true:false;
if(d && d.checked)
{
clearTimeout(timer);
timer=null;
timer=setTimeout("Rescan()",15*1000);//update every 15 seconds
}
else
{
clearTimeout(timer);
timer=null;
}
}
function GenerateSignalStrengthIndicator(strength)
{
var table="";
var cell="";
var count=0;
if(strength>=-60)
{
cell="<td style='background-color:green' height='5' width='1'></td>";
count=5;
}
else if(strength>=-73)
{
cell="<td style='background-color:green' height='5' width='1'></td>";
count=4;
}
else if(strength>=-85)
{
cell="<td style='background-color:yellow' height='5' width='1'></td>";
count=3;
}
else if(strength>=-98)
{
cell="<td style='background-color:yellow' height='5' width='1'></td>";
count=2;
}
else if(strength>=-110)
{
cell="<td style='background-color:red' height='5' width='1'></td>";
count=1;
}
else
{
cell="<td style='background-color:red' height='5' width='1'></td>";
count=0;
}
table+="<table border='0'>";
for(row=0;row<1;row++)
{
table+="<tr>";
for(col=0;col<count;col++)
{
table+=cell;
}
table+="</tr>";
}
table+="</table>";
return table;
}

function SetNetworkLinks()
{
document.getElementById('netdhcpD').style.display = (
(document.getElementById('netdhcp').innerHTML == 'N/A' ||
document.getElementById('netdhcp').innerHTML == 'Off') ?
'none' : 'inline'
);
}

function SetInterfaceDisplay(xml)
{
displayElementRootNames = new Array();
SetSubmit(false);



SetDisplaySelection('Interface.BOOTP');
SetDisplaySelection('Interface.DHCP');
SetDisplaySelection('Interface.Domain');
SetDisplaySelection('Interface.Hostname');
SetDisplaySelection('Interface.DHCP_Client_ID');



SetDisplaySelection('Interface.Default_Gateway');
SetDisplaySelection('Interface.IP_Address');
SetDisplaySelection('Interface.Primary_DNS');
SetDisplaySelection('Interface.Secondary_DNS');

SetDisplaySelection('Interface.MTU');

document.getElementById("networkform").style.display = "block";
}

function EthernetSpeedChange(value)
{
if(value == "Auto")
{
SetFxDisplay("ethernetduplexauto_Display", "");
SetFxDisplay("ethernetduplexhalf_Display", "");
SetFxDisplay("ethernetduplexfull_Display", "none");
}
else if(value == "1000")
{
SetFxDisplay("ethernetduplexauto_Display", "none");
SetFxDisplay("ethernetduplexhalf_Display", "none");
SetFxDisplay("ethernetduplexfull_Display", "none");
}
else
{
SetFxDisplay("ethernetduplexauto_Display", "none");
SetFxDisplay("ethernetduplexhalf_Display", "");
SetFxDisplay("ethernetduplexfull_Display", "");
}
Update();
}

function SetEthernetDisplay(xml)
{
displayElementRootNames = new Array();
SetSubmit(false);
var speed = SetDisplaySelection('Ethernet.Speed');
EthernetSpeedChange(speed);
SetDisplaySelection('Ethernet.Duplex');
document.getElementById("networkethform").style.display = "block";
}

function EthernetConfigPostProcedure()
{
FileSystemMonitor();
return ajax_EthernetConfPost(
[
true,
ajaxGetFormValuesWithoutClearingThem('networkethform')
]
);
}

function NetworkRender(xml)
{
var netno = Number(document.getElementById("hiddennetwork").innerHTML);
var d = document.getElementById("multinetworkdropdown");
if(d)
{
var r = "<";
r += "select name='navSelect' ";
r += "id='navSelect' ";
r += "onchange=\" ";
r += "var nav2 = document.getElementById('hiddennetworkinterfacelink').innerHTML;";
r += "var nav3 = document.getElementById('hiddennetworkstatusconfig').innerHTML;";
r += "document.getElementById('hiddennetwork').innerHTML = this.value;";
r += "return ajax_AddToHistory(";
r += "'NetworkPage', ";
r += "[true, 'netnumber=' + this.value + '&2=' + nav2 + '&3=' + nav3]";
r += ");";
r += " \" ";
r += ">";
for(var i = 0; i < 1 + 0; ++i)
{
var sel;
if(netno == i)
{
sel = " SELECTED ";
}
else
{
sel = "";
}
r += "<option value='" + i + "' " + sel + ">";
r += "Network " + (i + 1);
r += "</option>";
}
r += "</select>";
d.innerHTML = "";
d.innerHTML = r;
}

var scanResultTable = document.getElementById("wlanScanTable");
if(scanResultTable)
{
var row=scanResultTable.rows[1];//firstChild.nextSibling.firstChild;//get to first row: this has issue in FF
while(row)
{
col=row.getElementsByTagName('td')[3];//get the signal strength column
var strength=parseInt(col.innerHTML);
var originalContent=col.innerHTML;
col.innerHTML=GenerateSignalStrengthIndicator(strength)+originalContent;
row=row.nextSibling;
}
}

return;
}
