function GetRealTextNode(node)
{
if(node.hasChildNodes() && node.firstChild.nodeType != 3)
{
return node.firstChild;
}
else if(node.hasChildNodes() && node.childNodes[1].nodeType == 1)
{
return node.childNodes[1];
}
else if(node.hasChildNodes() && node.firstChild.nodeType == 1)
{
return node.firstChild;
}
return null;
}

function GetHiddenFrameOutput(hframe)
{
var i;
var j;
var target;
var data;
var nodes = window.frames[hframe].document.getElementsByTagName('xml');
for(i = 0; i < nodes.length; ++i)
{
var node = GetRealTextNode(nodes[i]);
if(node)
{
target = null;
data = null;
for(j = 0; j < node.childNodes.length ; ++j)
{
if(
node.childNodes[j].nodeName.toLowerCase() == "target" &&
node.childNodes[j].firstChild
)
{
target = node.childNodes[j].firstChild.nodeValue;
}
else if(node.childNodes[j].nodeName.toLowerCase() == "data")
{
data = node.childNodes[j];
}
}
if(target && data)
{
eval(target + "(data);");
}
}
}
}

confirmPostProcedure = "";

function PrintMsg(xml, id)
{
var d = document.getElementById(id);
if(d)
{
fadeObj = new fx.Opacity(id, {duration: 800});
fadeObj.hide();
var isStr = true;
if(xml.firstChild)
{
isStr = false;
}
if(
(xml.nodeType == 1 && ! xml.firstChild) || /* iframe xml parse empty */
(isStr && xml.length == 0) ||
(
! isStr &&
(! xml.firstChild || xml.firstChild.nodeValue == '')
)
)
{
/* Clear. */
d.innerHTML = '';
d.style.display = 'none'; /* Don't display (iehack) */
}
else
{
var r = d.innerHTML;
if(
(isStr && xml == 'br') ||
(! isStr && xml.firstChild.nodeValue == 'br')
)
{
/* Newline catch. */
r += "<br>";
}
else
{
/* Append. */
var msg = isStr ? xml : xml.firstChild.nodeValue;
var detectedReturnChar = (msg.charAt(msg.length - 1) == '\r')
if(detectedReturnChar)
{
msg = msg.substring(0, msg.length - 1);
}
{
/* Trim the last line if not terminated by <br/>. */
var lastBr = r.lastIndexOf("<br>");
var lastBrUpperCase = r.lastIndexOf("<BR>");
if(lastBrUpperCase >= 0)
{
lastBr = lastBrUpperCase;
}
if(lastBr >= 0)
{
if(lastBr < r.length - 4)
{
r = r.substring(0, lastBr + 4);
}
}
else
{
r = '';
}
}
if(msg.match(/^CONFIRM:/))
{
r += "<b>";
r += "<span class=\"errorLog\">";
r += msg;
r += " [<a ";
r += 'href="javascript:void(0)"';
r += 'onclick="';
r += "var confirms = GetDisplayValue('confirms');";
r += "SetDisplayValue('confirms', '' + confirms + '" + msg + "');";
r += confirmPostProcedure;
r += "return false;";
r += '"';
r += ">Okay</a>]";
r += " [<a ";
r += 'href="javascript:void(0)"';
r += 'onclick="';
r += "var curData = ajaxHistory.getCurrentData();";
r += "var curPage = ajaxHistory.getCurrentLocation();";
r += "return ajax_AddToHistory(curPage, curData);";
r += '"';
r += ">Cancel</a>]";
r += "</span>";
r += "</b>";
}
else
{
if(msg.match(/^ERROR:/))
{
r += "<span class=\"errorLog\">";
}
else if(msg.match(/^WARNING:/))
{
r += "<span class=\"warnLog\">";
}
else
{
r += "<span class=\"okLog\">";
}
r += msg + "</span>";
}
if(! detectedReturnChar)
{
r += "<br>";
}
}
d.innerHTML = r;
d.style.display = 'block';
}
fadeObj.toggle();
}
}

function PrintPostResults(xml)
{
PrintMsg(xml, 'results');
}

function GetXmlData(node, tag)
{
var e = node.getElementsByTagName(tag);
if(e.length != 1) /* Should only be one entry. */
{
return null;
}
else if(e[0].firstChild == null)
{
return "";
}
return e[0].firstChild.nodeValue;
}

function GetXmlBool(node, tag)
{
var d = GetXmlData(node, tag);
return (d && d == "1");
}

/*helper function to convert xml node to string*/
function XMLToString(oXML)
{
if(oXML==null)return "";
if (window.ActiveXObject)
{
return oXML.xml;
}
else
{
return (new XMLSerializer()).serializeToString(oXML);
}
}

function GetMsgAndDisplay(xml)
{
if(! xml || ! xml.hasChildNodes())
{
alert("ERROR: Unable to display message.");
}
else
{
var f = GetXmlData(xml, "f");
var c = GetXmlData(xml, "c");
var i = GetXmlData(xml, "i");
var msg = _msgs[c][i];
eval(f + "(msg);");
}
}

function GetMsgAndDisplayPrintf(xml)
{
if(! xml || ! xml.hasChildNodes())
{
alert("ERROR: Unable to display message.");
}
else
{
var f = GetXmlData(xml, "f");
var c = GetXmlData(xml, "c");
var i = GetXmlData(xml, "i");
if(c == "http" && (i == "62" || i == "63"))
{
var pageRefreshtimer = setTimeout(function(){window.location.href= "http://" + window.location.host ;},3000);
}
var msg = _msgs[c][i];
var finalMsg = msg.slice(0); /* Copy the message. */
var args = xml.getElementsByTagName('arg');
for(var i = 0; i < args.length; i++)
{
finalMsg = decodeURIComponent(finalMsg);
finalMsg = finalMsg.replace(
/\{\}/,
args[i].firstChild ? args[i].firstChild.nodeValue : ""
);
}
eval(f + "(finalMsg);");
}
}

function MainStatusRender(xml)
{
IndexDisplayElement(document.getElementById('status_Index'));
document.getElementById('documentData').innerHTML = '';
document.getElementById('subnavData').innerHTML = '';
var d = document.getElementById('contentData');
d.innerHTML = '';
var r = '<h2>Device Status</h2>';
if(! xml || ! xml.hasChildNodes())
{
r += "No MIB data is available.";
}
else
{
r += "<table class=\"basicTable statusTable\">";
r += "<tr class=\"statusHeader\"><td colspan=\"3\"><b>Product Information</b></td></tr>";
r += "<tr><td><b>Product Type:</b></td><td colspan=\"2\">" + GetXmlData(xml, "pn") + "</td></tr>";
r += "<tr><td><b>Firmware Version:</b></td><td colspan=\"2\">" + GetXmlData(xml, "fv") + "</td></tr>";



r += "<tr><td><b>Build Date:</b></td><td colspan=\"2\">" + GetXmlData(xml, "fbd") + "</td></tr>";
r += "<tr><td><b>Serial Number:</b></td><td colspan=\"2\">" + GetXmlData(xml, "sn") + "</td></tr>";
r += "<tr><td><b>Uptime:</b></td><td colspan=\"2\">" + GetXmlData(xml, "up") + "</td></tr>";







var configState=GetXmlData(xml, "pc");
r += "<tr><td><b>Permanent Config:</b></td><td colspan=\"2\">" + configState;
if(configState=="Unsaved")
{
r += "&nbsp;&nbsp;";
r += "<a href=\"javascript:void(0)\" ";
r += "onclick=\"";
r += "ajax_AddToHistory(";
r += "'StatusPage',";
r += "[true, 'cfgsave=true']";
r += ");";
r += "return false;";
r += "\"";
r += ">";
r += "<b>[Save]</b>";
r += "</a>";
//r += "<br>";
//r += "<img width=\"18\" height=\"18\" src=\"/config/warning.gif\" />&nbsp;";
//r += "<span class=\"warnLog\">WARNING: Some configuration changes have not been written to Flash.</span>";
}
r += "</td></tr>";



r += "<tr class=\"statusHeader\"><td colspan=\"3\"><b>Network Settings</b></td></tr>";
r += "<tr><td><b>Interface:</b></td><td colspan=\"2\">" + GetXmlData(xml, "intfc") + "</td></tr>";
r += "<tr><td><b>Link:</b></td><td colspan=\"2\">" + GetXmlData(xml, "link") + "</td></tr>";
r += "<tr><td><b>MAC Address:</b></td><td colspan=\"2\">" + GetXmlData(xml, "mac") + "</td></tr>";
r += "<tr><td><b>Hostname:</b></td><td colspan=\"2\">" + GetXmlData(xml, "host") + "</td></tr>";
r += "<tr><td><b>IP Address:</b></td><td colspan=\"2\">" + GetXmlData(xml, "ip") + "</td></tr>";
r += "<tr><td><b>Default Gateway:</b></td><td colspan=\"2\">" + GetXmlData(xml, "rtr") + "</td></tr>";
r += "<tr><td><b>Domain:</b></td><td colspan=\"2\">" + GetXmlData(xml, "dom") + "</td></tr>";
r += "<tr><td><b>Primary DNS:</b></td><td colspan=\"2\">" + GetXmlData(xml, "pdns") + "</td></tr>";
r += "<tr><td><b>Secondary DNS:</b></td><td colspan=\"2\">" + GetXmlData(xml, "sdns") + "</td></tr>";

r += "<tr><td><b>MTU:</b></td><td colspan=\"2\">" + GetXmlData(xml, "mtu") + "</td></tr>";




r += "<tr class=\"statusHeader\">";
r += "<td colspan=\"3\"><b>Line Settings</b></td>";
r += "</tr>";
var numSerialPorts = GetXmlData(xml, "numSerialPorts");
for(var line = 1; line <= numSerialPorts; ++line)
{
var name = GetXmlData(xml, "line" + line + "name");
r += "<tr>";
r += "<td><b>";
r += (
name.length > 0 ? name :



"Line " + line
);
r += ":</b></td>";
r += "<td colspan=\"2\">";
r += GetXmlData(xml, "line" + line + "set");
r += "</td>";
r += "</tr>";
}
r += "<tr class=\"statusHeader\">";
r += "<td><b>Tunneling</b></td>";
r += "<td><b>Connect<br>Mode</b></td>";
r += "<td><b>Accept<br>Mode</b></td>";
r += "</tr>"
var numTunnelPorts = GetXmlData(xml, "numTunnelPorts");
for(var line = 1; line <= numTunnelPorts; ++line)
{
r += "<tr>";
r += "<td><b>Tunnel " + line + ":" + "</b></td>";
r += "<td>" + GetXmlData(xml, "tun" + line + "con") + "</td>";
r += "<td>" + GetXmlData(xml, "tun" + line + "acc") + "</td>";
r += "</tr>";
}
r += "</table>";
}
d.innerHTML = r;
}

function WebMgrLogoutEnable(xml)
{
var lc = document.getElementById("logoutContainer");
if (lc)
{
lc.style.display = "block";
}
}

function WebMgrLogoutDisable(xml)
{
var lc = document.getElementById("logoutContainer");
if (lc)
{
lc.style.display = "none";
}
}

function HighlightElementInTable(tableId, elementId)
{
var navTable = document.getElementById(tableId);
if(navTable != undefined){
var entries = navTable.getElementsByTagName("td");
for(var i = 0; i < entries.length; ++i)
{
entries[i].style.border = '1px solid #efefef';
}
var e = document.getElementById(elementId);
if(e != undefined){
e.style.border = '1px solid #999';
}
}
}

function SetNav(xml)
{
var n1 = GetXmlData(xml, 'n1');
var n2 = GetXmlData(xml, 'n2');
var n3 = GetXmlData(xml, 'n3');
if(n1 != undefined)
{
HighlightElementInTable("Nav1", n1);
}
if(n2 != undefined)
{
HighlightElementInTable("Nav2", n2);
}
if(n3 != undefined && n3 >= 0){
HighlightElementInTable(n2 + "_Nav", n2 + "_" + (1 + Number(n3)));
document.getElementById(n2 + '_OptNav').style.display = 'inline';
}
}

showIdPrevious = "";
function ShowId(id)
{
var d = document.getElementById(showIdPrevious);
if(d)
{
d.style.display = 'none';
}
showIdPrevious = id;
d = document.getElementById(id);
if(d)
{
d.style.display = 'block';
}
}

function replaceString(mainStr, searchStr, replaceStr)
{
var foundOffset = mainStr.indexOf(searchStr);
if(foundOffset == -1)
{
return mainStr;
}
else
{
var front = mainStr.substring(0,foundOffset);
var back = mainStr.substring(foundOffset+searchStr.length,mainStr.length);
return front + replaceStr + replaceString(back,searchStr,replaceStr);
}
}

function stringMatch(x, y)
{
var x1 = replaceString(x, "&gt;", ">");
var y1 = replaceString(y, "&gt;", ">");
return (x1 == y1);
}

//*****************************************************************************
// Provide a common means to display file system compacting in web displays
var fileSystemStatusXmlHttp;
var fileSystemStatusEnable = false;
var fileSystemStatusTimer = null;

function FileSystemMonitor(){
fileSystemStatusEnable = true;
fileSystemStatusTimer=setTimeout("PollFileSystemStatus()", 1000);
}

function FileSystemMonitorDisable()
{
fileSystemStatusEnable = false;
clearTimeout(fileSystemStatusTimer);
fileSystemStatusTimer=null;
}

function PollFileSystemStatus(){
fileSystemStatusXmlHttp = ajax.getRequestObject();
if(fileSystemStatusXmlHttp){
var url = "/file_system_status?" + Date();
fileSystemStatusXmlHttp.open("GET", url, true);
fileSystemStatusXmlHttp.onreadystatechange = FileSystemStatusCallback;
fileSystemStatusXmlHttp.send(null);

clearTimeout(fileSystemStatusTimer);
fileSystemStatusTimer=null;
if(fileSystemStatusEnable)
{
fileSystemStatusTimer=setTimeout("PollFileSystemStatus()", 2000);
}
}
}

function FileSystemStatusCallback(){
if(fileSystemStatusXmlHttp && fileSystemStatusEnable){
if(fileSystemStatusXmlHttp.readyState == 4){
if(fileSystemStatusXmlHttp.status == 200){
if(
fileSystemStatusXmlHttp.responseText &&
fileSystemStatusXmlHttp.responseText.length > 0
){
var text = "" + fileSystemStatusXmlHttp.responseText + '\r';
PrintMsg(text, "results");
}
}
}
}
}

function GetInputElementValue(ie)
{
if(ie.type=="select-one")
{
if(ie.selectedIndex >= 0 && ie.selectedIndex < ie.length)
{
return ie.options[ie.selectedIndex].value;
}
return "";
}
else if(ie.type=="checkbox")
{
return ie.checked ? "Enabled" : "Disabled";
}
else if(ie.type==undefined && ie.length>0 && ie[0].type=="radio")
{
for(var i=0; i<ie.length; ++i)
{
if(ie[i].checked)
{
return ie[i].value;
}
}
return "";
}
else
{
return ie.value;
}
}

function GetDisplayValue(name)
{
var ie = document.forms[0].elements[name];
if(! ie)
{
return "";
}
return GetInputElementValue(ie);
}

function SetDisplayValue(name, value)
{
var n = document.forms[0].elements[name];
if(n)
{
if(n.type=="select-one")
{
for(var i=0; i<n.length; ++i)
{
if(n.options[i].value==value)
{
n.selectedIndex=i;
break;
}
}
}
else if(n.type=="checkbox")
{
n.checked = value == "Enabled";
}
else if(n.type==undefined && n.length>0 && n[0].type=="radio")
{
for(var i=0; i<n.length; ++i)
{
n[i].checked = n[i].value==value ? true : false;
}
}
else
{
n.value = value;
}
}
}

function GetDivValue(e)
{
return e.textContent == undefined ? e.innerText : e.textContent;
}

function GetDivValueById(id)
{
var e = document.getElementById(id);
return GetDivValue(e);
}

function SetDisplaySelection(name)
{
displayElementRootNames.push(name);
var cvalue = GetDivValueById("current_" + name);
var s = document.getElementById("status_" + name);
if(s)
{
var svalue = GetDivValue(s);
s.style.backgroundColor = (cvalue == svalue ? "" : "yellow");
}
SetDisplayValue("new_" + name, cvalue);
return cvalue;
}

function SetSubmit(enable, xml)
{
SetButtonVisibilities(xml);

if(document.getElementById('apply_button'))
{
fadeInOutApply.clearTimer();
fadeInOutApply.custom(
fadeInOutApply.now,
IsApplyButtonForcedToBeVisible() || enable ? 1 : 0
);
}
if(document.getElementById('submit_button'))
{
fadeInOutSubmit.clearTimer();
fadeInOutSubmit.custom(
fadeInOutSubmit.now,
IsSubmitButtonForcedToBeVisible() || enable ? 1 : 0
);
}
if(document.getElementById('test_button'))
{
//Test Connection button is always available
fadeInOutTest.clearTimer();
fadeInOutTest.custom(
fadeInOutTest.now,
true/*IsSubmitButtonForcedToBeVisible()*/ || enable ? 1 : 0
);
}
var rb = document.getElementById('reassert_button');
if(rb)
{
rb.style.backgroundColor = "yellow";
var displayReasert = false;
if(! IsSubmitButtonForcedToBeVisible() && ! enable)
{
for(var i = 0; i < displayElementRootNames.length; ++i)
{
var name = displayElementRootNames[i];
var c = document.getElementById("current_"+name);
var s = document.getElementById("status_"+name);
if(c && s && GetDivValue(c) != GetDivValue(s))
{
displayReasert = true;
break;
}
}
}
fadeInOutReassert.clearTimer();
fadeInOutReassert.custom(
fadeInOutReassert.now,
displayReasert ? 1 : 0
);
}
}

function Update(optElement)
{
if(optElement)
{
if(
optElement.value == "<None>" ||
optElement.value == "<Configured>" ||
optElement.value == "<Random>" ||
optElement.value == "<Default>"
)
{
optElement.select();
}
}
var somethingChanged = false;
for(var i = 0; i < displayElementRootNames.length; ++i)
{
var name = displayElementRootNames[i];
var cvalue = GetDivValueById("current_" + name);
var nvalue = GetInputElementValue(
document.forms[0].elements["new_" + name]
);
if(cvalue != nvalue)
{
somethingChanged = true;
break;
}
}
SetSubmit(somethingChanged);
}

//*****************************************************************************
// Support "sticky" tabs on the index display
var PreviousIndexDisplayElement;
function IndexDisplayElement(e)
{
if(PreviousIndexDisplayElement == undefined)
{
PreviousIndexDisplayElement = document.getElementById("status_Index");
}
PreviousIndexDisplayElement.style.backgroundColor = '#ff8000';
PreviousIndexDisplayElement = e;
e.style.backgroundColor = '#999';
}
function IndexIdChange(xml)
{
var id = GetXmlData(xml, "id");
if(id)
{
IndexDisplayElement(document.getElementById(id));
}
}
